//    Multimedia Jukebox Version 1.1- Plays a list of MID, WAV, AVI, etc.
//    multimedia files.
//
//    (c) Copyright 1997 by Software Impressions. All Rights Reserved.
//    This code is supplied "As Is" without any expressed or implied
//    warranty of any kind.
//
//    You may use this program (C++Builder Source and Executable) for
//    whatever non-commercial purpose you desire. If you find this
//    software useful and want to express your gratitude in the
//    "Shareware spirit", you can send $10.00 to the author,
//    Jeb Long at:
//
//    Software Impressions
//    P.O. Box 786
//    La Canada, CA 91011
//
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Main.h"
#include "About.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TMainform *Mainform;
//---------------------------------------------------------------------------
__fastcall TMainform::TMainform(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMainform::FormShow(TObject *Sender)
{
	PlayListFile = GetCurrentDir()+"\\PlayList.jbx";
}
//---------------------------------------------------
void __fastcall TMainform::PlayIt()
{
    if (PlayList->Items->Count > 0 )  // Any files to play?
    {

	    TrackBar1->Position = 0;         // Initialize the trackbar pointer
	    if (PlayList->ItemIndex == -1)   // Selected first item if no item
     		PlayList->ItemIndex = 0;     //   was selected
		MediaPlayer1->Close();           // Stop Playing current file
    	MediaPlayer1->FileName = PlayList->Items->Strings[PlayList->ItemIndex];
        					//  Tell player which file to play and start player
        MediaPlayer1->Open();
        Timer1->Enabled = TRUE;		// Start 1 second timer
        MediaPlayer1->Notify = TRUE;   // Tell player to execute ON NOTIFY
        MediaPlayer1->Play();
        // File status bar panels with status info
        int iLastSlash = MediaPlayer1->FileName.LastDelimiter("\\");
		AnsiString asString = MediaPlayer1->FileName;
        StatusBar1->Panels->Items[1]->Text =
            "Playing: " + asString.SubString(iLastSlash+1,asString.Length());
        StatusBar1->Panels->Items[0]->Text = asString.SubString(0,iLastSlash);
       	ElapsedTime();
		Tracker();
    }
    else
    {	// No files to play...
    	Timer1->Enabled = FALSE;
	    TrackBar1->Position = 0;
    }

}
//----------------------------------------------------------------------
//  Compute and display elapsed playing time
void __fastcall TMainform::ElapsedTime()
{
	char szTimeBuffer[30];
	MediaPlayer1->TimeFormat = tfSMPTE25; //
	int iSeconds = (MediaPlayer1->Length & 0xFF0000) >> 16;
    int iMinutes = (MediaPlayer1->Length & 0xFF00) >> 8;
    sprintf(szTimeBuffer,"%02d:%02d",iMinutes,iSeconds);
    StatusBar1->Panels->Items[2]->Text = szTimeBuffer;
}
//-----------------------------------------------------------------------------
// Setup Trackbar with length of multimedia object
void __fastcall TMainform::Tracker()
{
	MediaPlayer1->TimeFormat = tfMilliseconds;
    TrackBar1->Max = MediaPlayer1->Length;
    TrackBar1->Position  = MediaPlayer1->Position;   // Set current position
    TrackBar1->Frequency = MediaPlayer1->Length/10;  // Set scale
}
//---------------------------------------------------------------------------
// Copy selected file list file(s) to play list.
// (Multiple selections are allowed.)
void __fastcall TMainform::GetOneClick(TObject *Sender)
{
	int FileCount = FileListBox1->Items->Count;
    for (int iFile = 0; iFile < FileCount;iFile++)
    {
    	if (FileListBox1->Selected[iFile])
			AddFileName(iFile);	// Add file to play list
    }
    if (MediaPlayer1->Mode != mpPlaying)
	    PlayIt(); // Play file if one is not playing already
}
//---------------------------------------------------------------------------
// Copy all files in the file list to the Play list
void __fastcall TMainform::MoveAllClick(TObject *Sender)
{
  	int FileCount = FileListBox1->Items->Count;
    for (int iFile = 0; iFile < FileCount;iFile++)
       	AddFileName(iFile);
    if (MediaPlayer1->Mode != mpPlaying)
    	PlayIt();
}
//---------------------------------------------------------------------------
// remove currently selected file from playlist
void __fastcall TMainform::RemoveOneClick(TObject *Sender)
{
	if (PlayList->ItemIndex > -1)
    	PlayList->Items->Delete(PlayList->ItemIndex);
    if (PlayList->ItemIndex == -1 && PlayList->Items->Count > 0)
    {
    	PlayList->ItemIndex = 0;
        PlayIt();
    }
    else
        Timer1->Enabled = FALSE;

}
//---------------------------------------------------------------------------
// Remove all files from the playlist and turn off the player
void __fastcall TMainform::RemoveAllClick(TObject *Sender)
{
    Timer1->Enabled = FALSE;
	MediaPlayer1->Close();
	PlayList->Clear();
}
//---------------------------------------------------------------------------
// If user double clicks on a filelist file, move it to the play list.
void __fastcall TMainform::FileListBox1DblClick(TObject *Sender)
{
	AddFileName(FileListBox1->ItemIndex);
    if (PlayList->ItemIndex == -1)
        PlayIt();
}
//----------------------------------------------------------------------------
// User clicked on a play list file --- Play it
void __fastcall TMainform::PlayListClick(TObject *Sender)
{
	PlayIt();
}
//---------------------------------------------------------------------------
// Add file in the filelist to the playlist
void __fastcall TMainform::AddFileName(int iIndex)
{
	AnsiString asFileName;
    asFileName = DirectoryListBox1->Directory + "\\"+
                 FileListBox1->Items->Strings[iIndex];
	PlayList->Items->Add(asFileName);
}
//---------------------------------------------------------------------------
// If Media player finishes playing file, play the next file if there are any.
//
void __fastcall TMainform::MediaPlayer1Notify(TObject *Sender)
{
	if (MediaPlayer1->NotifyValue==nvSuccessful &&
        PlayList->ItemIndex < PlayList->Items->Count-1)
   	{
    	PlayList->ItemIndex++;
        PlayIt();
    }
}
//---------------------------------------------------------------------------
// One second timer event files ... This event is called. reposition trackbar
//  pointer.  Also, if file is finished, play next file.
//
void __fastcall TMainform::Timer1Timer(TObject *Sender)
{
    if (MediaPlayer1->Position == MediaPlayer1->Length &&
        PlayList->ItemIndex < PlayList->Items->Count-1)
    {
        Timer1->Enabled = FALSE;
       	PlayList->ItemIndex++;
    	MediaPlayer1->Position=0;
        PlayIt();
    }
	TrackBar1->Position= MediaPlayer1->Position;
}
//---------------------------------------------------------------------------
// If user moves trackbar pointer, reposition the multimedia player play
// location.
void __fastcall TMainform::TrackBar1Change(TObject *Sender)
{
	 MediaPlayer1->Position = TrackBar1->Position;
}
//---------------------------------------------------------------------------
void __fastcall TMainform::DirectoryListBox1Change(TObject *Sender)
{
             StatusBar1->Panels->Items[0]->Text = Label1->Caption;
}
//---------------------------------------------------------------------------
void __fastcall TMainform::FileListBox1DragOver(TObject *Sender,
	TObject *Source, int X, int Y, TDragState State, bool &Accept)
{
	// only accept drops from the list boxes
    Accept = (Source == PlayList || Source == FileListBox1);
}
//---------------------------------------------------------------------------
void __fastcall TMainform::FileListBox1DragDrop(TObject *Sender,
	TObject *Source, int X, int Y)
{
	// if dropping an item where it came from, then don't do anything
    if (Sender == Source)
    {
    	if (Source == PlayList)
        {
		    int iIndex = PlayList->ItemAtPos( Point (X,Y), true);
        	if (iIndex >= 0)
            {
                PlayList->Items->Move(PlayList->ItemIndex,iIndex);
                PlayList->ItemIndex = iIndex;
            }
        }
	}
    else
    { // move item(s) from one list to the other
	    if (Source == FileListBox1)
    	    GetOneClick(Sender);
		else
			if (Source == PlayList)
    			RemoveOneClick(Sender);
     }
}
//---------------------------------------------------------------------------
void __fastcall TMainform::FileListBox1MouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if (Button != mbLeft)
    	return;
    TListBox *Listbox = (TListBox *) Sender;
    // make sure that we are on an item in the list
    if (Listbox->ItemAtPos (Point (X,Y),true)>= 0)
    	Listbox->BeginDrag(false);

}
//---------------------------------------------------------------------------
void __fastcall TMainform::SavePlayListClick(TObject *Sender)
{
	if (PlayList->Items->Count > 0)
    	PlayList->Items->SaveToFile(PlayListFile);
    else
    	Application->MessageBox("Play list is empty","Error",MB_OK | MB_ICONHAND);
}
//---------------------------------------------------------------------------
void __fastcall TMainform::loadPlayFileClick(TObject *Sender)
{
	try
    {
    	FILE *pPlayFile;
        if ((pPlayFile = fopen(PlayListFile.c_str(),"rt")) != NULL)
        {
        	fclose(pPlayFile);
			PlayList->Items->LoadFromFile(PlayListFile);
		    if (PlayList->Items->Count > 0)
    		{
   				PlayList->ItemIndex = 0;
		        PlayIt();
    		}
    		else
            	Application->MessageBox("Play list is empty","Error",MB_OK | MB_ICONHAND);
        }
   		else
           	Application->MessageBox("Play list file is not available","Error",MB_OK | MB_ICONHAND);
    }
    catch (Exception &exception)
	{
		Application->ShowException(&exception);
	}

}
//---------------------------------------------------------------------------
void __fastcall TMainform::HelpButtonClick(TObject *Sender)
{
	AboutBox->ShowModal();
}
//---------------------------------------------------------------------------
